!CODE

# Input
str	 =chop(gets())
dim_x=psplit(str,"|",0)
par_x=psplit(str,"|",1)
op   =psplit(str,"|",2)
dim_y=psplit(str,"|",3)
par_y=psplit(str,"|",4)

# ( Row&Col )
xi = int(split(dim_x,"x",0))
xj = int(split(dim_x,"x",1))
yi = int(split(dim_y,"x",0))
yj = int(split(dim_y,"x",1))

xs = (xi==0&&xj==0); xv = (xi==0&&xj!=0);
ys = (yi==0&&yj==0); yv = (yi==0&&yj!=0);

# ( Init X )
if( xs ){ x=atov(par_x) }						# Scalar
else{
	if( xv ){									# Vector
		for( j=0 ; j<xj; j++ ){ x[j]=atov(split(par_x,",",j)) }
	}
	else{										# Matrix
		for( i=0 ; i<xi; i++ ){
			for( j=0 ; j<xj; j++ ){ x[i,j]=atov(split(par_x,",",i*xj+j)) }
		}
	}
}

# ( Init Y )
if( ys ){ y=atov(par_y) }						# Scalar
else{
	if( yv ){									# Vector
		for( j=0 ; j<yj; j++ ){ y[j]=atov(split(par_y,",",j)) }
	}
	else{										# Matrix
		for( i=0 ; i<yi; i++ ){
			for( j=0 ; j<yj; j++ ){ y[i,j]=atov(split(par_y,",",i*yj+j)) }
		}
	}
}

# Process & Output
swch(op){
	case "+" : ans = x +  y; break;
	case "-" : ans = x -  y; break;
	case "*" : ans = x *  y; break;
	case "/" : ans = x /  y; break;
	case "%" : ans = x %  y; break;
	case "**": ans = x ** y; break;
	case "@@": ans = x @@ y; break;
	case "<>": ans = x <> y; break;
	case "><": ans = x >< y; break;
}

ai = row(ans)
aj = col(ans)
as = (ai==0&&aj==0); av = (ai==0&&aj!=0);

if( as )										# Scalar
	print("%v\n",ans)
else{
	if( av ){									# Vector
		print("{")
		loop( j<aj ){
			print("%v%s",ans[j],j<aj-1?",":"}\n")
		}
	}
	else{										# Matrix
		print("{")
		loop( i<ai ){
			print("{")
			loop( j<aj ){
				print("%v%s",ans[i,j],j<aj-1?",":"}")
			}
			print("%s",i<ai-1?",":"}\n")
		}
	}
}

!DATA
|0x3|1,2,3|+|0x0|3|								# 行ベクトル OP スカラー
{4,5,6}

|0x3|1,2,3|-|0x0|3|
{-2,-1,0}

|0x3|1,2,3|*|0x0|3|
{3,6,9}

|0x3|1,2,3|/|0x0|3|
{0,0,1}

|0x3|1,2,3|%|0x0|3|
{1,2,0}

|0x3|1,2,3|**|0x0|3|
{1,8,27}

|0x0|3|+|0x3|1,2,3|								# (逆)
{4,5,6}

|0x0|3|-|0x3|1,2,3|
{2,1,0}

|0x0|3|*|0x3|1,2,3|
{3,6,9}

|0x0|3|/|0x3|1,2,3|
{3,1,1}

|0x0|3|%|0x3|1,2,3|
{0,1,0}

|0x0|3|**|0x3|1,2,3|
{3,9,27}

|1x3|1,2,3|+|0x0|3|								# 行マトリクス OP スカラー
{{4,5,6}}

|1x3|1,2,3|-|0x0|3|
{{-2,-1,0}}

|1x3|1,2,3|*|0x0|3|
{{3,6,9}}

|1x3|1,2,3|/|0x0|3|
{{0,0,1}}

|1x3|1,2,3|%|0x0|3|
{{1,2,0}}

|1x3|1,2,3|**|0x0|3|
{{1,8,27}}

|0x0|3|+|1x3|1,2,3|								# (逆)
{{4,5,6}}

|0x0|3|-|1x3|1,2,3|
{{2,1,0}}

|0x0|3|*|1x3|1,2,3|
{{3,6,9}}

|0x0|3|/|1x3|1,2,3|
{{3,1,1}}

|0x0|3|%|1x3|1,2,3|
{{0,1,0}}

|0x0|3|**|1x3|1,2,3|
{{3,9,27}}

|3x1|1,2,3|+|0x0|3|								# 列ベクトル OP スカラー
{{4},{5},{6}}

|3x1|1,2,3|-|0x0|3|
{{-2},{-1},{0}}

|3x1|1,2,3|*|0x0|3|
{{3},{6},{9}}

|3x1|1,2,3|/|0x0|3|
{{0},{0},{1}}

|3x1|1,2,3|%|0x0|3|
{{1},{2},{0}}

|3x1|1,2,3|**|0x0|3|
{{1},{8},{27}}

|0x0|3|+|3x1|1,2,3|								# (逆)
{{4},{5},{6}}

|0x0|3|-|3x1|1,2,3|
{{2},{1},{0}}

|0x0|3|*|3x1|1,2,3|
{{3},{6},{9}}

|0x0|3|/|3x1|1,2,3|
{{3},{1},{1}}

|0x0|3|%|3x1|1,2,3|
{{0},{1},{0}}

|0x0|3|**|3x1|1,2,3|
{{3},{9},{27}}

|2x3|1,2,3,4,5,6|+|0x0|3|						# 行列 OP スカラー
{{4,5,6},{7,8,9}}

|2x3|1,2,3,4,5,6|-|0x0|3|
{{-2,-1,0},{1,2,3}}

|2x3|1,2,3,4,5,6|*|0x0|3|
{{3,6,9},{12,15,18}}

|2x3|1,2,3,4,5,6|/|0x0|3|
{{0,0,1},{1,1,2}}

|2x3|1,2,3,4,5,6|%|0x0|3|
{{1,2,0},{1,2,0}}

|2x3|1,2,3,4,5,6|**|0x0|3|
{{1,8,27},{64,125,216}}

|0x0|3|+|2x3|1,2,3,4,5,6|						# (逆)
{{4,5,6},{7,8,9}}

|0x0|3|-|2x3|1,2,3,4,5,6|
{{2,1,0},{-1,-2,-3}}

|0x0|3|*|2x3|1,2,3,4,5,6|
{{3,6,9},{12,15,18}}

|0x0|3|/|2x3|1,2,3,4,5,6|
{{3,1,1},{0,0,0}}

|0x0|3|%|2x3|1,2,3,4,5,6|
{{0,1,0},{3,3,3}}

|0x0|3|**|2x3|1,2,3,4,5,6|
{{3,9,27},{81,243,729}}

|0x3|1,2,3|+|0x3|2,4,6|							# 行ベクトル OP 行ベクトル
{3,6,9}

|0x3|1,2,3|-|0x3|2,4,6|
{-1,-2,-3}

|0x3|1,2,3|*|0x3|2,4,6|
{2,8,18}

|0x3|1,2,3|/|0x3|2,4,6|
{0,0,0}

|0x3|1,2,3|%|0x3|2,4,6|
{1,2,3}

|0x3|1,2,3|**|0x3|2,4,6|
{1,16,729}

|0x3|1,2,3|+|1x3|2,4,6|							# 行ベクトル OP 行マトリクス
{3,6,9}

|0x3|1,2,3|-|1x3|2,4,6|
{-1,-2,-3}

|0x3|1,2,3|*|1x3|2,4,6|
{2,8,18}

|0x3|1,2,3|/|1x3|2,4,6|
{0,0,0}

|0x3|1,2,3|%|1x3|2,4,6|
{1,2,3}

|0x3|1,2,3|**|1x3|2,4,6|
{1,16,729}

|1x3|1,2,3|+|0x3|2,4,6|							# (逆)
{3,6,9}

|1x3|1,2,3|-|0x3|2,4,6|
{-1,-2,-3}

|1x3|1,2,3|*|0x3|2,4,6|
{2,8,18}

|1x3|1,2,3|/|0x3|2,4,6|
{0,0,0}

|1x3|1,2,3|%|0x3|2,4,6|
{1,2,3}

|1x3|1,2,3|**|0x3|2,4,6|
{1,16,729}

|1x3|1,2,3|+|1x3|2,4,6|							# 行マトリクス OP 行マトリクス
{{3,6,9}}

|1x3|1,2,3|-|1x3|2,4,6|
{{-1,-2,-3}}

|1x3|1,2,3|*|1x3|2,4,6|
{{2,8,18}}

|1x3|1,2,3|/|1x3|2,4,6|
{{0,0,0}}

|1x3|1,2,3|%|1x3|2,4,6|
{{1,2,3}}

|1x3|1,2,3|**|1x3|2,4,6|
{{1,16,729}}

|2x3|1,2,3,4,5,6|+|2x3|2,4,6,8,10,12|			# 行列 OP 行列
{{3,6,9},{12,15,18}}

|2x3|1,2,3,4,5,6|-|2x3|2,4,6,8,10,12|
{{-1,-2,-3},{-4,-5,-6}}

|2x3|1,2,3,4,5,6|*|2x3|2,4,6,8,10,12|
{{2,8,18},{32,50,72}}

|2x3|1,2,3,4,5,6|/|2x3|2,4,6,8,10,12|
{{0,0,0},{0,0,0}}

|2x3|1,2,3,4,5,6|%|2x3|2,4,6,8,10,12|
{{1,2,3},{4,5,6}}

|2x3|1,2,3,4,5,6|**|2x3|2,4,6,8,10,12|
{{1,16,729},{65536,9765625,2176782336}}

|0x3|1,2,3|@@|3x1|2,4,6|						# 行ベクトル @@ 列ベクトル
28

|1x3|1,2,3|@@|3x1|2,4,6|
28

|0x3|1,2,3|@@|3x2|1,2,3,4,5,6|					# 行ベクトル @@ 行列
{22,28}

|1x3|1,2,3|@@|3x2|1,2,3,4,5,6|
{22,28}

|3x1|1,2,3|@@|0x3|2,4,6|						# 列ベクトル @@ 行ベクトル
{{2,4,6},{4,8,12},{6,12,18}}

|3x1|1,2,3|@@|1x3|2,4,6|
{{2,4,6},{4,8,12},{6,12,18}}

|2x3|1,2,3,4,5,6|@@|3x1|2,4,6|					# 行列 @@ 列ベクトル
{{28},{64}}

|2x3|1,2,3,4,5,6|@@|3x2|2,4,6,8,10,12|			# 行列 @@ 行列
{{44,56},{98,128}}

|0x3|1,2,3|<>|0x3|4,5,6|						# ベクトルの内積(3次元行ベクトル <> 3次元行ベクトル)
32

|0x3|1,2,3|><|0x3|4,5,6|						# ベクトルの外積(3次元行ベクトル >< 3次元行ベクトル)
{-3,6,-3}
